/* Ratios.
 *
 * PegSoft miscellaneous library (c) 2004 PegSoft
 * Contact us at pegsoft@pegsoft.net
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this software (the COPYING file); if not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139,
 * USA.
 *
 */

/** 
 * \file misc/ratio.h
 * \brief Ratio class.
 */

#ifndef MISC_RATIO_H
#define MISC_RATIO_H

/*************************************************************************/

namespace misc
{

/*************************************************************************/

/// Class representing a ratio.

/** This class is used to represent a ratio. */

class Ratio
{
	public:
		/// Default constructor.
		Ratio() : m_x(0), m_y(0) { }
		/// Constructor setting x and y.
		Ratio(int32_t x, int32_t y) : m_x(x), m_y(y) { }
		/// Copy constructor.
		Ratio(Ratio const &r) : m_x(r.m_x), m_y(r.m_y) { }
		/// Assignment operator.
		Ratio &operator=(Ratio const &right);
		
		/// Comparison operator.
		bool operator==(Ratio const &right);
		
		/// Returns the X value.
		int32_t x() const { return m_x; }
		/// Sets the X value.
		int32_t x(int32_t x) { return (m_x = x); }
		/// Returns the Y value.
		int32_t y() const { return m_y; }
		/// Sets the Y value.
		int32_t y(int32_t y) { return (m_y = y); }
	private:
		int32_t m_x;
		int32_t m_y;
};

/*************************************************************************/

} /* namespace misc */

/*************************************************************************/

#endif /* MISC_RATIO_H */
