/* Configuring modules.
 *
 * PegSoft modules subsystem library (c) 2005 PegSoft
 * Contact us at pegsoft@pegsoft.net
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this software (the COPYING file); if not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139,
 * USA.
 *
 */

/** 
 * \file modules/conf.h
 * \brief Modules configuration directives header file.
 */

#ifndef MODULES_CONF_H
#define MODULES_CONF_H

/*************************************************************************/

#include <string>

#include <conf/directives.h>

/*************************************************************************/

namespace modules
{

/*************************************************************************/

/// Class implementing the module configuration directive.

class ConfModule : public conf::ConfBlock
{
	public:
		/* Data */
		conf::ConfString mname;
		conf::ConfString config;
	
		/* Functions */
		explicit ConfModule(std::string const &name, bool reloadable = true);
	protected:
		virtual bool add(conf::Conf &conf, conf::Conf &new_conf);
};

/*************************************************************************/

class ConfModuleA : public conf::ConfArray<ConfModule, std::vector<ConfModule> >
{
	public:
		ConfModuleA();
};

/*************************************************************************/

/// Class implemeting the load-module configuration directive.

class LoadModule : public conf::ConfStrCharA
{
	public:
		LoadModule();
};

/*************************************************************************/

} /* namespace modules */

/*************************************************************************/

#endif /* MODULES_CONF_H */
