/* How do you want to chat today?
 *
 * Epona (c) 2000-2002, 2004 PegSoft
 * Contact us at epona@pegsoft.net
 *
 * Based on the original code of Services by Andy Church.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program (see the file COPYING); if not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef CONF_H
#define CONF_H

/*************************************************************************/

#include <string>

#include <cmdline/cmdline.h>
#include <conf/parser.h>
#include <conf/quick.h>

/*************************************************************************/

namespace core
{

/*************************************************************************/

class EConfLogger : public conf::ConfLogger
{
	public:
		virtual void warning(std::string const &context, unsigned int line,
				std::string const &msg);
		virtual void error(std::string const &context, unsigned int line,
				std::string const &error);
#if DEBUG
		virtual void debug(std::string const &context, unsigned int line,
				int type, std::string const &msg);
#endif
};

/*************************************************************************/

class EConfGlobalQ : public conf::ConfGlobalQ
{
	public:
		EConfGlobalQ();
		
		virtual bool setup();
	private:
		typedef cmdline::CmdLineParser::ParamsList::const_iterator PIType;
		typedef cmdline::CmdLineParser::VarsList::const_iterator VIType;
		
		EConfGlobalQ(EConfGlobalQ const &);
		EConfGlobalQ &operator=(EConfGlobalQ const &);
		
		bool add_paths(std::string const &p, PIType &beg, PIType &end);
		bool add_vars(std::string const &p, PIType &beg, PIType &end);
};

/*************************************************************************/

} /* namespace core */

/*************************************************************************/

#endif /* CONF_H */
