/* Legacy databases module.
 *
 * Epona (c) 2000-2002, 2004 PegSoft
 * Contact us at epona@pegsoft.net
 *
 * Based on the original code of Services by Andy Church.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program (see the file COPYING); if not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef MODULE_H
#define MODULE_H

/*************************************************************************/

#include <core/version.h>
#include <modules/module.h>

#include "password.h"

/*************************************************************************/

namespace core { class Epona; }

/*************************************************************************/

namespace legacydb 
{

/*************************************************************************/

/// The legacydb module class
class LegacyDB : public modules::Module
{
	public:
		/// Constructor.
		LegacyDB(core::Epona &core);
		
		/// Overrides Module::factory().
		virtual modules::Interface *factory(modules::PSIID iid);
		
		/// Overrides Module::interface().
		virtual modules::Interface *interface(modules::PSIID iid);
		
		/// Implements Module::version().
		virtual int version() const { return core::program_version; }
		
		/// Returns the core module.
		core::Epona &core() { return *m_core; }
	private:
		core::Epona *m_core;
		Encrypter m_enc;
};

/*************************************************************************/

} /* namespace legacydb */

/*************************************************************************/

#endif /* MODULE_H */
