/* MySQL connection.
 *
 * MySQL database module (c) 2005 PegSoft
 * Contact us at pegsoft@pegsoft.net
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program (see the file COPYING); if not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef CONN_H
#define CONN_H

/*************************************************************************/

#include <mysql-cli/conn.h>

/*************************************************************************/
	
namespace mysql 
{

/*************************************************************************/

/// Our own MySQL connection class.

class Events : public mysql_cli::Events
{
	public:
		/// Overrides mysql_cli::Events::copy().
		virtual Events *copy() const { return new Events(*this); }
		/// Overrides mysql_cli::Conn::log_event().
		virtual void log_event(mysql_cli::Conn &conn, int event,
				unsigned int code, char const *msg) const;
	private:
		/// Logs an error message, with error() appended if applicable.
		void log_perror(mysql_cli::Conn &conn,
				char const *format, ...) const;
};

/*************************************************************************/

} /* namespace mysql */

/*************************************************************************/

#endif /* CONN_H */
