/* Configuration.
 *
 * SMTP mail transport module (c) 2007 PegSoft
 * Contact us at pegsoft@pegsoft.net
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program (see the file COPYING); if not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <system/headers.h>

#include "conf.h"
#include "decl.h"
#include "module.h"
#include "smtp.h"
#include "transport.h"

using namespace std;

/*************************************************************************/

namespace smtp_cli
{

/*************************************************************************/

bool Transport::deliver(mail::Mail const &mail, bool *temp)
{
	if (me->socks_size() > me->cd().limit)
	{
		errorf("Too many sockets in use");
		
		*temp = true;
		return false;
	}
	
	if (m_update)
	{
		char const *err;
		
		if (!m_template.set_remote(me->cd().relay, me->cd().port, &err))
		{
			errorf("Resolve error: %s", err);
			
			*temp = false;
			return false;
		}
		
		m_update = false;
	}
	
	SMTPSocket *s = new SMTPSocket(m_template, mail);
	me->add_sock(s);
	
	if (!s->connect())
	{
		if (errno)
			errorf("Connect error: %s", strerror(errno));
		else
			errorf("Connect error");
		delete s;
		
		*temp = true;
		return false;
	}
	
	return true;
}

/*************************************************************************/

} /* namespace smtp_cli */

/*************************************************************************/
