/* Transport interface.
 *
 * SMTP mail transport module (c) 2007 PegSoft
 * Contact us at pegsoft@pegsoft.net
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program (see the file COPYING); if not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef TRANSPORT_H
#define TRANSPORT_H

/*************************************************************************/

#include <mail/transport.h>

#include "smtp.h"

/*************************************************************************/
	
namespace smtp_cli 
{

/*************************************************************************/

class Transport : public mail::Transport
{
	public:
		/* Constants */
		
		/// Unique interface identifier
		static modules::PSIID const IID = 0x461ce123;
		
		/* Functions */
		
		/// Constructor.
		Transport() : m_template(), m_update(true) { }

		/// Implements mail::Transport::deliver().
		virtual bool deliver(mail::Mail const &mail, bool *temp);
		
		/// Updates template.
		void update_template() { m_update = true; }
	private:
		SMTPSocket m_template;
		bool m_update;
};

/*************************************************************************/

} /* namespace smtp_cli */

/*************************************************************************/

#endif /* TRANSPORT_H */
